import ogr
import os

def DumpAllFeatures(lyr):
    lyr.ResetReading()
    feat = lyr.GetNextFeature()
    while feat is not None:
        feat.DumpReadable()
        feat = lyr.GetNextFeature()
    feat = None

try:
    os.unlink('rfc35_test.dbf')
    os.unlink('rfc35_test.shp')
    os.unlink('rfc35_test.shx')
except:
    pass

ds = ogr.GetDriverByName('ESRI Shapefile').CreateDataSource('rfc35_test.dbf')
lyr = ds.CreateLayer('rfc35_test')

fd = ogr.FieldDefn('foo5', ogr.OFTString)
fd.SetWidth(5)
lyr.CreateField(fd)

feat = ogr.Feature(lyr.GetLayerDefn())
feat.SetField(0, 'foo0')
lyr.CreateFeature(feat)
feat = None

fd = ogr.FieldDefn('bar10', ogr.OFTString)
fd.SetWidth(10)
lyr.CreateField(fd)

feat = ogr.Feature(lyr.GetLayerDefn())
feat.SetField(0, 'foo1')
feat.SetField(1, 'bar1')
lyr.CreateFeature(feat)
feat = None

ds = None
ds = ogr.Open('rfc35_test.dbf', update = 1)
lyr = ds.GetLayer(0)

fd = ogr.FieldDefn('baz15', ogr.OFTString)
fd.SetWidth(15)
lyr.CreateField(fd)

feat = ogr.Feature(lyr.GetLayerDefn())
feat.SetField(0, 'foo2')
feat.SetField(1, 'bar2_01234')
feat.SetField(2, 'baz2_0123456789')
lyr.CreateFeature(feat)
feat = None

fd = ogr.FieldDefn('baw20', ogr.OFTString)
fd.SetWidth(20)
lyr.CreateField(fd)

feat = ogr.Feature(lyr.GetLayerDefn())
feat.SetField(0, 'foo3')
feat.SetField(1, 'bar3_01234')
feat.SetField(2, 'baz3_0123456789')
feat.SetField(3, 'baw3_012345678901234')
lyr.CreateFeature(feat)
feat = None

DumpAllFeatures(lyr)

print('lyr.ReorderField(1,3)')
lyr.ReorderField(1,3)
DumpAllFeatures(lyr)

print('lyr.ReorderField(3,1)')
lyr.ReorderField(3,1)
DumpAllFeatures(lyr)
    
print('lyr.DeleteField(0)')
lyr.DeleteField(0)
DumpAllFeatures(lyr)

print('lyr.ReorderField(0,2)')
lyr.ReorderField(0,2)
DumpAllFeatures(lyr)

print('lyr.ReorderField(2,0)')
lyr.ReorderField(2,0)
DumpAllFeatures(lyr)

print('lyr.ReorderField(0,1)')
lyr.ReorderField(0,1)
DumpAllFeatures(lyr)

print('lyr.ReorderField(1,0)')
lyr.ReorderField(1,0)
DumpAllFeatures(lyr)

print('lyr.ReorderFields([2,1,0])')
lyr.ReorderFields([2,1,0])
DumpAllFeatures(lyr)

print('lyr.ReorderFields([2,1,0])')
lyr.ReorderFields([2,1,0])
DumpAllFeatures(lyr)

print('lyr.DeleteField(2)')
lyr.DeleteField(2)
DumpAllFeatures(lyr)

print('lyr.ReorderField(1,0)')
lyr.ReorderField(1,0)
DumpAllFeatures(lyr)

new_fd = ogr.FieldDefn("baz25", ogr.OFTString)
new_fd.SetWidth(25)

lyr_defn = lyr.GetLayerDefn()
print('lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("baz15"), new_fd, ogr.ALTER_ALL_FLAG)')
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("baz15"), new_fd, ogr.ALTER_ALL_FLAG)

DumpAllFeatures(lyr)


new_fd = ogr.FieldDefn("bar5", ogr.OFTString)
new_fd.SetWidth(5)

lyr_defn = lyr.GetLayerDefn()
print('lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("bar10"), new_fd, ogr.ALTER_ALL_FLAG)')
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("bar10"), new_fd, ogr.ALTER_ALL_FLAG)

DumpAllFeatures(lyr)

lyr.ResetReading()
feat = lyr.GetNextFeature()
feat = None

new_fd = ogr.FieldDefn('anintfield', ogr.OFTInteger)
new_fd.SetWidth(10)
lyr.CreateField(new_fd)

new_fd = ogr.FieldDefn('strfield', ogr.OFTString)
new_fd.SetWidth(10)
lyr.CreateField(new_fd)

lyr.ResetReading()
feat = lyr.GetNextFeature()
print('after adding 2 fields')
feat.DumpReadable()

lyr.ResetReading()
feat = lyr.GetNextFeature()
feat.SetField(0, 'X12340123401234012340123X')
feat.SetField(1, 'Y123Y')
feat.SetField('anintfield', 123)
feat.SetField('strfield', 'XZ')
lyr.SetFeature(feat)
feat = None

new_fd = ogr.FieldDefn('anintfield', ogr.OFTInteger)
new_fd.SetWidth(15)
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("anintfield"), new_fd, ogr.ALTER_ALL_FLAG)

new_fd.SetWidth(5)
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("anintfield"), new_fd, ogr.ALTER_ALL_FLAG)

new_fd = ogr.FieldDefn("nowastrfld", ogr.OFTString)
new_fd.SetWidth(15)
lyr_defn = lyr.GetLayerDefn()
print('lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("anintfield"), new_fd, ogr.ALTER_ALL_FLAG)')
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("anintfield"), new_fd, ogr.ALTER_ALL_FLAG)

DumpAllFeatures(lyr)


new_fd = ogr.FieldDefn('strfield', ogr.OFTString)
new_fd.SetWidth(5)
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("strfield"), new_fd, ogr.ALTER_ALL_FLAG)
DumpAllFeatures(lyr)


new_fd = ogr.FieldDefn('strfield', ogr.OFTString)
new_fd.SetWidth(15)
lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("strfield"), new_fd, ogr.ALTER_ALL_FLAG)
DumpAllFeatures(lyr)

#new_fd = ogr.FieldDefn("nowastrfld", ogr.OFTString)
#new_fd.SetWidth(10)
#lyr_defn = lyr.GetLayerDefn()
#print('lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("nowastrfld"), new_fd, ogr.ALTER_ALL_FLAG)')
#lyr.AlterFieldDefn(lyr_defn.GetFieldIndex("nowastrfld"), new_fd, ogr.ALTER_ALL_FLAG)

#DumpAllFeatures(lyr)

ds = None
